﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace Contest01
{
    public partial class frmContest01 : Form
    {
        public frmContest01()
        {
            InitializeComponent();
        }

        private int MaxCycle(int a)
        {
            int c = 1;
            while (a != 1)
            {
                if (a % 2 == 0)
                {
                    a = a / 2;
                    c++;
                }
                else
                {
                    a = 3 * a + 1;
                    c++;
                }
            }
            return c;
        }
        private int getAnswer(int a, int b)
        {
            //int a = 0, b = 0; //input
            int max = MaxCycle(a);
            for (int i = a + 1; i <= b; i++)
            {
                int cycle = MaxCycle(i);
                if (max < cycle)
                {
                    max = cycle;
                }
            }
            return max;
        }
        private void btnStart_Click(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.FileName = "contest.txt";
            ofd.Filter = "Text files (*.txt)|*.txt|All files(*.*)|*.*";
            ofd.Multiselect = false;
            ofd.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
            ofd.ShowDialog(this);

            string[] lines = File.ReadAllLines(ofd.FileName);
            int i, j;
            string[] answers = new string[lines.Length];
            int count=0;
            foreach (string item in lines)
            {
                string[] splited=item.Split(' ');
                i = int.Parse(splited[0]);
                j = int.Parse(splited[1]);
                answers[count++] = item + ' ' + getAnswer(i, j).ToString();
            }
            SaveFileDialog sfd = new SaveFileDialog();
            sfd.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.DesktopDirectory);
            sfd.FileName = "answer.txt";
            sfd.ShowDialog(this);

            File.WriteAllLines(sfd.FileName, answers);
            MessageBox.Show(string.Format("تعداد {0} فقره داده پردازش شد.",lines.Length.ToString()),
                "Programming Challenges",MessageBoxButtons.OK, 
                MessageBoxIcon.Information,MessageBoxDefaultButton.Button1,
                MessageBoxOptions.RightAlign|MessageBoxOptions.RtlReading);
        }
    }
}
